package cologne.eck.js_cal;
import java.io.*;


import javax.swing.JOptionPane;

import cologne.eck.tools.TestLog;


class DatenSetzen {
	
	private static String lineSep =  System.getProperty("line.separator"); // "\n";//
	
	private static String jsDateiName = null;//JS_Setter.getJsFileName();
	private static int startJahr = 2013; // Wird ausgelesen aus JS-Datei
	
	private static String[] monthNames;
	
	
	/////////////////////////////////////////////////////////////////
	//
	// Hilfsfunktion: Loeschen
	//
	// an einzelnen Tagen alle Termine loeschen
	// jsDatei wird eingelesen, betreffende Monats-Zeilen veraendern:
	// Datum und TerminText wird (mit vorherigem oder folgendem Komma) geloescht
	// Alte jsDatei wird als old gespeichert, tempDatei als jsDaei
	private static void tagLoeschen(int jahr, int monat, int tag) {
		//TestLog.o(DatenSetzen.class, "tagLoeschen");
		
		if (jsDateiName == null) {
			jsDateiName = JS_Setter.getJsFileName();
		}
		

	    File jsDatei = new File(jsDateiName);//Kalender.jsDateiName);
	    // Temporaer-Datei, in die geschrieben wird, ist nachher = neuer jsDatei	    
	    //File tempDatei = new File( Kalender.jsDateiName.substring(0, Kalender.jsDateiName.length() - 2 ) + "temp");		
	    // Ehemalige jsDatei vor der Aenderung mit "-" zur Unterschedung anderer oldDateien
	    //File oldDatei = new File( Kalender.jsDateiName.substring(0, Kalender.jsDateiName.length() - 2 ) + "old-");
	    // Temporaer-Datei, in die geschrieben wird, ist nachher = neuer jsDatei	    
	    File tempDatei = new File( jsDateiName.substring(0, jsDateiName.length() - 2 ) + "temp");		
	    // Ehemalige jsDatei vor der Aenderung mit "-" zur Unterschedung anderer oldDateien
	    File oldDatei = new File( jsDateiName.substring(0, jsDateiName.length() - 2 ) + "old-");		

	    
	    BufferedReader buffRead = null;
		BufferedWriter buffWrite = null;
			
	    //
		// aus jsDatei lesen
		try {			
			buffRead = new BufferedReader(new FileReader(jsDatei));
		
			//
			// in tempDatei schreiben
			try {
				// Ueberscherieben existierender Datei (ohne true)
				buffWrite = new BufferedWriter(new FileWriter(tempDatei));
		
				String zeile = "";// StringBuilder lohnt nicht... 
				
				// Zum Vergleichen mit den Zeilen:
				String zeilenAnfangEinmalig = "TermineEinmalig[" + (jahr - startJahr) + "][" + monat + "]";
				String zeilenAnfangJaehrlich = "TermineJaehrlich[" + monat + "]";
				
				//
				// ZEILEN-SCHLEIFE:
				// Datei Zeilenweise einlesen und in tempDatei schreiben
				// dabei nur die Zeilen des angegebenen Monats aendern
				//
				while ((zeile = buffRead.readLine()) != null) {

					boolean einmalig = true;// Termin einmalig(true) oder jaehrlich(false)
										
					// Die richtige Zeilen: einmalig oder jaehrlich
					if ( zeile.startsWith(zeilenAnfangEinmalig) || zeile.startsWith(zeilenAnfangJaehrlich) ) { 						

			 			// Pruefen ob in der Zeile (im Monat) Termin vorhanden ist: 
            			if (zeile.substring(28, zeile.indexOf(')') ).indexOf('\"') == -1) {
            				//TestLog.o(DatenSetzen.class, "kein Termin im betreffenden Monat vorhanden");
	                		// Zeile unveraendert schreiben, naechste Zeile (Termin-Texte) ueberspringen:
	                		buffWrite.append(zeile + lineSep);
            				continue; // Zeilen einlesen fortfahren (jaehrliche bzw. einmalige Termine folgen eventuell noch)
            			}          

						int pos = 28; // Position des Termins im Array, mindestens 28, ab oeffneneder Klammer

						//
	                	// TERMIN-SCHLEIFE: 
	                	// die (richtige) Zeile Daten-weise durchgehen
	                	// die einzelnen Daten/Termine werden an den Anfuehringszeichen erkannt 
	                	//
	                	while ( pos != -1) { 

	                		// einzelne Daten ermitteln: zwischen zwei Anfuehrungszeichen
	                		int pos1 = zeile.indexOf('\"', pos); // das vordere Anfuehrungszeichen
	                		if (pos1 == -1)   { // kein Termin enthalten: Terminschleife abbrechen
	                			break;
	                		}
	                		int pos2 = zeile.indexOf('\"', pos1 + 1); // das folgende Anfuehrungszeichen
	                		if (pos2 == -1) {
	                			JOptionPane.showMessageDialog(null, "Fehler in Datei " + jsDatei.getPath() + lineSep 
	                					+ "Zugehoeriges Anfuehrungszeichen nicht enthalten" + lineSep 
	                					+ " Monat : " + monat + "  Tag: " +  tag + "  einmaliger Termin: " + einmalig);
	                		}
	                		
	                		// nur die Zahl, ohne Anfuehrungszeichen und Komma zum Parsen (Ueberpruefen):
	                		String zahlString = zeile.substring(pos1 + 1, pos2).trim(); 
	                		//TestLog.o(DatenSetzen.class, "zahlString : " + zahlString+ "  pos1: " + pos1 + "  pos2: "+ pos2 + "  pos: " +pos);
            				if (! Character.isDigit(zahlString.charAt(0)) ) {
	                			JOptionPane.showMessageDialog(null, "Fehler in Datei " + jsDatei.getPath() + lineSep 
	                					+ "Syntaxfehler in Array: " + zahlString + " ist keine Zahl" + lineSep 
	                					+ " Monat : " + monat + "  Tag: " +  tag + "  einmaliger Termin: " + einmalig);
            				}
	                		
	                		int datum = Integer.parseInt(zahlString.trim());
	                		if (datum < tag) { // einen Eintrag ueberspringen
	                			pos1 = zeile.indexOf('\"', pos2 + 1);
	                			if (pos1 == -1){
	                				break;
	                			}
	                			pos2 = zeile.indexOf('\"', pos1 + 1);
		                		if (pos2 == -1) {
		                			JOptionPane.showMessageDialog(null, "Fehler in Datei " + jsDatei.getPath() + lineSep 
		                					+ "Zugehoeriges Anfuehrungszeichen nicht enthalten" + lineSep 
		                					+ " Monat : " + monat + "  Tag: " +  tag + "  einmaliger Termin: " + einmalig);
		                		}
	                		}
	                		else if (datum > tag) { // am Termin vorbei... 
	                			break;//Terminschleife abbrechen
	                		}
	                		else if (datum == tag) { // Treffer!
	                			//
		                		// zu loeschenden Teilstring aus der Zeile ermitteln: 
	                			// mit Anfuehrungszeichen und 
	                			// - mit vorherigem Komma (weiterer Termin im Monat)
	                			// - mit folgendem Komma (erster Termin, dem weitere folgen)
	                			// - ohne Komma (erster und letzter = einziger Termin im Monat)
		                		//       
	                  			// pos1 = fuehrendes Anf., pos2 =  vor schliessendem Anfuehrungszeichen des Datums
	                			// hintere Position fuer zu loeschenden substring ermitteln:
	                			int zwischenPos = zeile.indexOf('\"', pos2 + 1);//fuehrendes Anf. des Textes
	                			pos2 = zeile.indexOf('\"', zwischenPos + 1);// schliessendes Anf. des Textes
	                			// Pruefen, ob naechste Termine am gleichen Tag ist:
                				int naechstePos1 = zeile.indexOf('\"', pos2 +1);
                				int naechstePos2 = zeile.indexOf('\"', naechstePos1 + 1);

	                			while (naechstePos1 != -1) {
	                				String datumsString = zeile.substring(naechstePos1 + 1, naechstePos2);
	                				if (Integer.parseInt(datumsString) == tag) {
		                				naechstePos1 = zeile.indexOf('\"', naechstePos2 +1);
		                				naechstePos2 = zeile.indexOf('\"', naechstePos1 + 1);// schliessendes Anf. des Textes
		                				pos2 = naechstePos2;
		                				// Auf naechstes Datum gehen:
		                   				naechstePos1 = zeile.indexOf('\"', naechstePos2 +1);
		                				naechstePos2 = zeile.indexOf('\"', naechstePos1 + 1);
	                				}
	                				else {
	                					break;
	                				}
	                			}	                			

		                		if (zeile.lastIndexOf(',',pos1) != -1) { // wenn Termin (Komma) davor vorhanden: Mit Komma loeschen 
		                			pos1 = zeile.lastIndexOf(',',pos1); // inklusive des letzten Kommas vor dem Termin
		                		}
		                		else { // erster Termin im Array, kein Komma vor Termin vorhanden		              
		                			// wenn weiterer Termin (Komma nach pos1 und vor schliessender Klammer) vorhanden:
		                			if ( ( zeile.substring( 0, zeile.lastIndexOf(')') ) ).indexOf(',', pos2) != -1) { // Komma nach Termin vorhanden               					                				
		                				pos2 = zeile.indexOf(',', pos2);  // folgendes Komma 
		                			}		                			
		                			// wenn kein weiterer Termin vorhanden: einziger Termin im Monat
		                			else {
		                				// nix tun: nur Termin selbst loeschen
		                			}		                			
		                		}
		                		//Anfang bis vor pos1 (ggf. Komma) +  ab nach pos2 (ggf.Komma) bis inkl. Ende 
		                		zeile = zeile.substring(0, pos1) + zeile.substring( pos2 + 1, zeile.length() ); 
	                			break; // da alle Termine des Tages erwischt
	                			//TestLog.o(DatenSetzen.class, "neueZeile : " + neueZeile);	                			                			                			
	                		} // if Treffer gefunden	
	                		else { // datum < tag
	                			// Texteintrag ueberspringen:
	                			pos1 = zeile.indexOf('\"', pos2 + 1 );
	                			pos2 = zeile.indexOf('\"', pos1 + 1 );
	                		}
	                		
	                   		pos = pos2 + 1;// hinter das hintere Anfuehrungszeichen	   
	                	} // Terminschleife while: Termine der richtigen Zeile einlesen   	                	
					} // if richtige Zeile	
					buffWrite.append(zeile + lineSep);				
				} // while: alle Zeilen einlesen
			// Exception buffWrite
			} catch (IOException ioe) {
				JOptionPane.showMessageDialog(null, "Fehler bei Schreib-Zugriff auf die Datei "+ tempDatei);
				TestLog.o(DatenSetzen.class, ioe.getMessage());
				ioe.printStackTrace();
			} finally {
				if (buffWrite != null) {
					try {
						buffWrite.close();
					} catch (IOException ioe) {
						JOptionPane.showMessageDialog(null, "Fehler: Datei "+ tempDatei + " kann nicht geschlossen werden.");
						TestLog.o(DatenSetzen.class, ioe.getMessage());
					}
				}
			}		
		// Exceptin buffRead
		} catch (IOException ioe) {
			JOptionPane.showMessageDialog(null, "Fehler bei Lese-Zugriff auf die Datei "+ jsDatei);
			TestLog.o(DatenSetzen.class, ioe.getMessage());
			ioe.printStackTrace();
		} finally {
			if (buffRead != null) {
				try {
					buffRead.close();
				} catch (IOException ioe) {
					JOptionPane.showMessageDialog(null, "Fehler: Datei "+ jsDatei + " kann nicht geschlossen werden.");
					TestLog.o(DatenSetzen.class, ioe.getMessage());
				}
			}
		}		
		// jsDatei in Datei mit Endung ".old-" umbenennen
		// tempDatei als regulaere ".js"-Datei abspeichern 
		// -> Windows-Probleme bei renameTo: Bei Fehlschlag die alte Datei vorher loeschen
		try {
			if (jsDatei.renameTo(oldDatei) == false) {
				//JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ jsDatei.getPath() + " zu " + oldDatei.getPath() );
				if (oldDatei.exists() ) {
					if (oldDatei.delete() == false) {
						JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ jsDatei.getPath() + " zu " + oldDatei.getPath()  
								+ lineSep + oldDatei + " kann nicht geloescht werden");
					}
					else {
						if (jsDatei.renameTo(oldDatei) == false) {
							JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ jsDatei.getPath() + " zu " + oldDatei.getPath() );
						}
					}
				}
			}
			if (tempDatei.renameTo(jsDatei) == false) {
				//JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ tempDatei.getPath() + " zu " + jsDatei.getPath() );
				if (jsDatei.exists() ) {
					if (jsDatei.delete() == false) {
						JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ tempDatei.getPath() + " zu " + jsDatei.getPath()  
								+ lineSep + jsDatei + " kann nicht geloescht werden");
					}
					else {
						if (tempDatei.renameTo(jsDatei) == false) {
							JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ tempDatei.getPath() + " zu " + jsDatei.getPath() );
						}
					}
				}
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Umbenennung fehlgeschlagen: " + oldDatei.getPath() + " und " + jsDatei.getPath());
			TestLog.o(DatenSetzen.class, e.getMessage());		
		}
	}
	
	
	////////////////////////////////////////////////////////////////////
	//
	// Hilfsfunktion: neues Jahr eroeffnen
	//
	//
	private static boolean neuesJahrEroeffnen(int jahr){	
		
		//TestLog.o(DatenSetzen.class, "neues Jahr: " + jahr);
		
		boolean erfolg = true; // Rueckgabewert ohne Exception
		
		
		if (jsDateiName == null) {
			jsDateiName = JS_Setter.getJsFileName();
		}
		// Bestehende JavaScript-Datei mit Terminen
	    File jsDatei = new File(jsDateiName);
	    // Temporaer-Datei, in die geschrieben wird, ist nachher = neuer jsDatei	    
	    File tempDatei = new File( jsDateiName.substring(0, jsDateiName.length() - 2 ) + "temp-new");		
	    // Ehemalige jsDatei vor der Aenderung mit "-" zur Unterschedung anderer oldDateien
	    File oldDatei = new File( jsDateiName.substring(0, jsDateiName.length() - 2 ) + "old-new");		

	    
		String zeilenAnfang = "ENDE Jahr "; // Zum Vergleichen mit den Zeilen
		int vorherigesJahr = 0;	// Jahr, nach dem neues Jahr eingefuegt wird			
	    
		// Nur Auslesen, um die Position zu bestimmen, 
		// an der das neue Jahr eingefuegt werden soll
		// -> vorherigesJahr wird gesetzt
	    BufferedReader buff1 = null;	
	    
		try {			
			buff1 = new BufferedReader(new FileReader(jsDatei));		
			String zeile = "";// StringBuilder lohnt nicht... 				
			// Datei lesend durchlaufen, um die Position zum Einfuegen zu bestimmen: 
			while ((zeile = buff1.readLine()) != null) {					
				if ( zeile.startsWith(zeilenAnfang)) { // ENDE Jahr ....
				String jahrString = zeile.substring( zeile.indexOf('2'), zeile.indexOf('2') + 4);
				//TestLog.o(DatenSetzen.class, "jahrString: " + jahrString);
				int zeilenJahr = Integer.parseInt(jahrString);
				if (zeilenJahr > vorherigesJahr && zeilenJahr < jahr) {
					vorherigesJahr = zeilenJahr;
				}						
				} else {
					continue;
				}							
			}
		} catch (IOException ioe) {
			JOptionPane.showMessageDialog(null, "Fehler 1 bei Lese-Zugriff auf die Datei "+ jsDatei);
			TestLog.o(DatenSetzen.class, ioe.getMessage());
			ioe.printStackTrace();
			erfolg = false;
		} finally {
			if (buff1 != null) {
				try {
					buff1.close();
				} catch (IOException ioe) {
					JOptionPane.showMessageDialog(null, "Fehler 1: Datei "+ jsDatei + " kann nicht geschlossen werden.");
					TestLog.o(DatenSetzen.class, ioe.getMessage());
					erfolg = false;
				}
			}
		}			    
    
	    
	    BufferedReader buffRead = null;
		BufferedWriter buffWrite = null;
			
	    //
		// aus jsDatei lesen:
		try {			
			buffRead = new BufferedReader(new FileReader(jsDatei));
		
			//
			// in tempDatei schreiben:
			try {
				// Ueberschreiben existierender Datei (ohne true)
				buffWrite = new BufferedWriter(new FileWriter(tempDatei));
		
				String zeile = "";// StringBuilder lohnt nicht... 
								
				if (vorherigesJahr == 0) { // frueheres Jahr als bestehende Jahre
					zeilenAnfang = "TermineEinmalig = new Array();";
				}
				else {
					zeilenAnfang = zeilenAnfang + vorherigesJahr; // ENDE Jahr 20xx
				}
				
				//TestLog.o(DatenSetzen.class, "zeilenAnfang: "+ zeilenAnfang);				
				while ((zeile = buffRead.readLine()) != null) {
					if ( zeile.startsWith(zeilenAnfang)) {
						buffWrite.append(zeile + lineSep); // End-Zeile schreiben
						int index = jahr - startJahr;
						String anfang = "TermineEinmalig[" + index + "]";
						buffWrite.append("/* " + lineSep);
						//TestLog.o(DatenSetzen.class, "/* " + lineSep);
						buffWrite.append("#->" + jahr + " */" + lineSep);
						buffWrite.append(anfang + " = new Array();"  + lineSep);
						for (int i = 0; i<12; i++) {
							//TestLog.o(DatenSetzen.class, anfang + "[" + i + "] = new Array();"  + lineSep);
							buffWrite.append(anfang + "[" + i + "] = new Array();"  + lineSep);
						}
						buffWrite.append("/* " + lineSep);
						buffWrite.append("ENDE Jahr " + jahr + " */" + lineSep);
						
						zeile = buffRead.readLine();
					}					
					buffWrite.append(zeile + lineSep);	
				}
		// Exception buffWrite
		} catch (IOException ioe) {
			JOptionPane.showMessageDialog(null, "Fehler bei Schreib-Zugriff auf die Datei "+ tempDatei);
			TestLog.o(DatenSetzen.class, ioe.getMessage());
			ioe.printStackTrace();
			erfolg = false;
		} finally {
			if (buffWrite != null) {
				try {
					buffWrite.close();
				} catch (IOException ioe) {
					JOptionPane.showMessageDialog(null, "Fehler: Datei "+ tempDatei + " kann nicht geschlossen werden.");
					TestLog.o(DatenSetzen.class, ioe.getMessage());
					erfolg = false;
				}
			}
		}		
	// Exceptin buffRead
	} catch (IOException ioe) {
		JOptionPane.showMessageDialog(null, "Fehler bei Lese-Zugriff auf die Datei "+ jsDatei);
		TestLog.o(DatenSetzen.class, ioe.getMessage());
		ioe.printStackTrace();
		erfolg = false;
	} finally {
		if (buffRead != null) {
			try {
				buffRead.close();
			} catch (IOException ioe) {
				JOptionPane.showMessageDialog(null, "Fehler: Datei "+ jsDatei + " kann nicht geschlossen werden.");
				TestLog.o(DatenSetzen.class, ioe.getMessage());
				erfolg = false;
			}
		}
	}		
	// jsDatei in Datei mit Endung ".old-" umbenennen
	// tempDatei als regulaere ".js"-Datei abspeichern 
	// -> Windows-Probleme bei renameTo: Bei Fehlschlag die alte Datei vorher loeschen
	try {
		if (jsDatei.renameTo(oldDatei) == false) {
			//JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ jsDatei.getPath() + " zu " + oldDatei.getPath() );
			if (oldDatei.exists() ) {
				if (oldDatei.delete() == false) {
					JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ jsDatei.getPath() + " zu " + oldDatei.getPath()  
							+ lineSep + oldDatei + " kann nicht geloescht werden");
				}
				else {
					if (jsDatei.renameTo(oldDatei) == false) {
						JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ jsDatei.getPath() + " zu " + oldDatei.getPath() );
					}
				}
			}
		}
		if (tempDatei.renameTo(jsDatei) == false) {
			//JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ tempDatei.getPath() + " zu " + jsDatei.getPath() );
			if (jsDatei.exists() ) {
				if (jsDatei.delete() == false) {
					JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ tempDatei.getPath() + " zu " + jsDatei.getPath()  
							+ lineSep + jsDatei + " kann nicht geloescht werden");
				}
				else {
					if (tempDatei.renameTo(jsDatei) == false) {
						JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ tempDatei.getPath() + " zu " + jsDatei.getPath() );
					}
				}
			}
		}
	} catch (Exception e) {
		JOptionPane.showMessageDialog(null, "Umbenennung fehlgeschlagen: " + oldDatei.getPath() + " und " + jsDatei.getPath());
		TestLog.o(DatenSetzen.class, e.getMessage());		
		erfolg = false;
	}
	
	return erfolg; // wenn keine Exception: true
}
	
	
	///////////////////////////////////////////////////////////////////////
	//
	// Ganze Tage mit allen Terminen setzen (update-Button aus Kalender)
	// Bestehendes wird ueberschrieben
	//
	// Aus dem Text koennen Monat und Tag ausgelesen werden
	static void tagSetzen (int jahr, String text) { 
		//TestLog.o(DatenSetzen.class, "tagSetzen");
		
		//TestLog.o(DatenSetzen.class, "text: " + text);
		String textZeilen[] = text.split("\n"); // lineSep funktioniert nicht bei Windows
		//for(int i=0; i<textZeilen.length;i++)		TestLog.o(DatenSetzen.class, "Zeile " + i + " " + textZeilen[i]);
		
		String zeile1 = textZeilen[0].trim();// Zeile mit Wochentag, Tag, Monat ohne Leerzeichen am Anfang
		//TestLog.o(DatenSetzen.class, "zeile1 : " + zeile1);
		String tagString = "";
		String monatsString = "";
		if (Character.isDigit(zeile1.charAt(4))) { // zweistelllige Zahl
			tagString = zeile1.substring(3,5);
			monatsString = zeile1.substring(6, zeile1.length());
		}
		else {
			tagString = zeile1.substring(3,4);
			monatsString = zeile1.substring(5, zeile1.length());
			//TestLog.o(DatenSetzen.class, "monatsString: " + monatsString + " MonatsNamen[0]: " + Kalender.monatsNamen[0]);
		}
		// Tag: 
		int tag = Integer.parseInt(tagString);	

		// Monat: 
		int monat = 0;
/*		String [] monatsNamen = {"Januar", "Februar", "Maerz", "April", "Mai", 
				"Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"};*/
		for (int i = 0; i<12; i++){
			if ( monatsString.equals(monthNames[i]) ) {
				monat = i;
				break;
			}			
		}
		// Achtung bei Jahreswechsel ist das Jahr falsch!
		int terminJahr = jahr;
	/*	if (Kalender.getInstance().isJahresWechsel() && monat == 11){
			terminJahr = terminJahr - 1;
		}*/
		
		// TextZeilen als Termine setzen, vorher alle Tages-Termine loeschen
		tagLoeschen(terminJahr, monat,tag);

		// Text setzen	
		for( int i = 1; i < textZeilen.length; i++) { // alle weiteren Zeilen: 
			String eintrag = textZeilen[i];
			if (eintrag.trim().startsWith("*")){// jaehrlicher Termin, eventuell Zeilen zusammenfassen
				// * weg, Zeile anfuegen mit Leerzeichen
				StringBuilder jahresTextBuilder = new StringBuilder();
				jahresTextBuilder = jahresTextBuilder.append( (eintrag.substring( eintrag.indexOf('*') + 1, eintrag.length() )  ).trim()).append(' ');
				terminSetzen(false, jahr, monat, tag, jahresTextBuilder.toString() );
			}
			else { // einmalige Termine:
				terminSetzen(true, terminJahr, monat, tag, eintrag.trim() );
				//TestLog.o(DatenSetzen.class, "jahr: " + terminJahr + "  monat: " + monat + "  tag: " + tag + "text: " + eintrag.trim());
			}
		}
	}
	
	///////////////////////////////////////////////////////
	//
	// Einzelne Termine setzen (Termin-Setter: ok-Button)
	// Termine werden in die Reihenfolge eingefuegt
	//
	private static void terminSetzen(boolean einmalig, int jahr, int monat, int tag, String text) {
		//TestLog.o(DatenSetzen.class, "terminText: " + text);
		//TestLog.o(DatenSetzen.class, "jar: " + jahr + "  monat: " + monat + "  tag: " + tag + "  text: " + text);
		
		
		// replace problematic chars: ( ) " ; 
		
		// Alle doppelte Anfuehrungszeichen im Text in einfache umwandeln: Sonst Probleme beim Auslesen
		text = text.replace('\"', '\'');
//		text = text.replace('"', '\'');
		text = text.replace(')', '}');
		text = text.replace('(', '{');
		//TestLog.o(DatenSetzen.class, "text: " + text + " " + tag + "  " + monat + "  " + jahr + "einmalig: " + einmalig);
		
		// Falls ohne Aufruf von Kalender wird jsDateiName nicht ausgelesen
/*		if (Kalender.jsDateiName.equals("")) {
			Properties prop = new Properties();	
			File propDatei = new File("config" + File.separator + Kalender.systemName + ".properties");    	
	    		try {    			
	    			prop.load(new FileInputStream(propDatei));
		    		Kalender.jsDateiName = prop.getProperty("JS-Datei"); // Schluessel: "JS-Datei"
		            //TestLog.o(DatenSetzen.class, prop.getProperty("JS-Datei"));			
				} catch (FileNotFoundException e1) {
					JOptionPane.showMessageDialog(null, "Die JavaScript-Datei, "
							+ "aus der die Termine gelesen werden, muss gesetzt werden." + File.separator
							+ "   Dateiname: \"jskalender.js\" ");
					// Wenn Datei nicht existiert: Datei neu erstellen und prop setzen
					PropertyVerwaltung.propDateiSetzen(propDatei.getPath(),"JS-Datei");
				} catch (IOException e1) {
					JOptionPane.showMessageDialog(null, "Fehler bei Zugriff auf Datei:"
							+ propDatei.getPath() );
				}
		}*/
		
		if (jsDateiName == null) {
			jsDateiName = JS_Setter.getJsFileName();
		}
		
	    File jsDatei = new File(jsDateiName);
	    File tempDatei = new File( jsDateiName.substring(0, jsDateiName.length() - 2 ) + "temp");		
	    File oldDatei = new File( jsDateiName.substring(0, jsDateiName.length() - 2 ) + "old");	
	    
	    BufferedReader buffRead = null;
		BufferedWriter buffWrite = null;
		
		boolean zeileEnthalten = true; // Erfolgsueberpruefung fuer einmalige Termine

	    //
		// aus jsDatei lesen
		try {			
			buffRead = new BufferedReader(new FileReader(jsDatei));
		
			//
			// in tempDatei schreiben
			try {
				// Ueberschreiben existierender Datei (ohne true)
				buffWrite = new BufferedWriter(new FileWriter(tempDatei));
		
				String zeile = "";
				StringBuilder zeilenBuilder = new StringBuilder(); // zum Zusammenbauen
								
				// Gesuchten Zeilenanfang zusammenbauen zum Vergleich ob richtige Zeile
				StringBuilder zeilenAnfangBuilder = new StringBuilder("Termine"); // Zeilenanfang zur Identifikation der richtigen Zeile
				if (einmalig == true) {
					zeilenAnfangBuilder = (zeilenAnfangBuilder.append("Einmalig[")).
							append(jahr - startJahr).
							append("][").append(monat).append("]");
					//TestLog.o(DatenSetzen.class, "jahr: " + jahr + "  startJahr: " + DatenEinlesen.startJahr);
					// Pruefen, ob die geforderte Zeile (Jahr) schon enthalten ist
					zeileEnthalten = false;
				}
				else {// Jaehrlicher Termin
					zeilenAnfangBuilder = zeilenAnfangBuilder.append("Jaehrlich[").append(monat).append("]");
				}
				String zeilenAnfang = zeilenAnfangBuilder.toString();// Vergleichsstring
				//TestLog.o(DatenSetzen.class, "zeilenAnfangBuilder: " + zeilenAnfangBuilder);
				
				//
				// Zeilenweise einlesen und in tempDatei schreiben:
				//
				while ((zeile = buffRead.readLine()) != null) { // Zeilenschleife
				
					if (! zeile.startsWith(zeilenAnfang )) { // wenn nicht die richtige Zeile
						// nix tun
					}
					else { // richtige Zeile fuer neues Termin-Datum
						
						zeileEnthalten = true;
						
						// Zum Einfuegen in die Zeile: Textlaenge + 4*Anfuehrungszeichen + Datum + Komma
						StringBuilder neuesDatum = new StringBuilder(text.length() + 8);
						
						// Wenn noch keine Termine im Monat vorhanden: Ohne fuehrendes oder folgendes Komma einsetzen
						if (zeile.substring(20, zeile.indexOf(')') ).indexOf('\"') == -1) {
							// eventuelle Kommentare am Zeilenende uebernehmen
							neuesDatum = neuesDatum.append('\"'). // "
									append(tag).append("\",\""). // tag","
									append(text).append('\"'); // text"
							zeilenBuilder = ( new StringBuilder ( zeile.substring(0,zeile.indexOf('(') + 1) ) ).// Anfang bis incl. (
									append(neuesDatum). // Datum und Text
									// ab incl. )  bis Ende (incl. eventueller Kommentare) 
									append(zeile.substring( zeile.lastIndexOf(')') , zeile.length() ) );
							//TestLog.o(DatenSetzen.class, "zeile: " + zeile + "  zeilemBuilder: " + zeilenBuilder);
						}
						else {						
							//
		                	// TERMIN-SCHLEIFE: 
		                	// die (richtige) Zeile Daten-weise durchgehen, parsen bis datum > tag, neuen Termin davor,
							// pruefen ob erster Termin -> mit Komma hinten dran, sonst mit Komma davor
		                	// die einzelnen Daten/Termine werden an den Anfuehrungszeichen erkannt 
		                	//
							int pos = 28; // Position des Termins im Array, mindestens 28
		                	while ( pos != -1 ) { 
		               			                		
		                		// einzelne Daten ermitteln: zwischen zwei Anfuehrungszeichen
		                		int pos1 = zeile.indexOf('\"', pos); // das vordere Anfuehrungszeichen des Datums
		                		if (pos1 == -1)   { // kein weiterer Termin mehr enthalten: Neuer Termin wird letzter Termin
		                			// vor die schliessende Klammer mit fuehrendem Komma einfuegen
		    						neuesDatum = neuesDatum.append(",\""). // ,"
											append(tag).append("\",\""). // tag","
											append(text).append('\"'); // text"
									zeilenBuilder = ( new StringBuilder ( zeile.substring(0, zeile.lastIndexOf(')') ) ) ).// Anfang bis vor/excl )
											append(neuesDatum). // Komma, Datum und Text
											// ab incl. )  bis Ende (incl. eventueller Kommentare) 
											append(zeile.substring( zeile.indexOf(')') , zeile.length() ) );
									break; // Terminschleife abbrechen
		                		}
		                		int pos2 = zeile.indexOf('\"', pos1 + 1); // das folgende Anfuehrungszeichen des Datums
		                		if (pos2 == -1) {
		                			JOptionPane.showMessageDialog(null, "Fehler in Datei " + jsDatei.getPath() + lineSep 
		                					+ "Zugehoeriges Anfuehrungszeichen nicht enthalten" + lineSep 
		                					+ " Monat : " + monat + "  Tag: " +  tag + "  einmaliger Termin: " + einmalig);
		                		}
		                		
		                		// nur die Zahl, ohne Anfuehrungszeichen und Komma zum Parsen (Ueberpruefen):
		                		String zahlString = zeile.substring(pos1 + 1, pos2).trim(); 
		                //TestLog.o(DatenSetzen.class, "zahlString : " + zahlString+ "  pos1: " + pos1 + "  pos2: "+ pos2 + "  pos: " +pos);
	            				if (! Character.isDigit(zahlString.charAt(0)) ) {
		                			JOptionPane.showMessageDialog(null, "Fehler in Datei " + jsDatei.getPath() + lineSep 
		                					+ "Syntaxfehler in Array: " + zahlString + " ist keine Zahl" + lineSep 
		                					+ " Monat : " + monat + "  Tag: " +  tag + "  einmaliger Termin: " + einmalig);
	            				}
	            				
	            				int datum = Integer.parseInt(zahlString.trim());
	            				if (datum <= tag) { // Schleife laeuft weiter: 
	            					// Termintext ueberspringen:
	            					pos1 = zeile.indexOf('\"', pos2 + 1);
	            					pos2 = zeile.indexOf('\"', pos1 + 1);
	            					pos = pos2 + 1;
	            					continue;
	            				}		                		
	            				// Termin Einfuegen: 
	            				else if (datum > tag) { // Position gefunden: vor pos1	                				               			
		                			//
			                		// vor pos1 einfuegen ggf. mit Komma davor oder danach mit Anfuehrungszeichen und
		                			// - mit vorherigem Komma (nicht-erster Termin im Monat)
		                			// - mit folgendem Komma (erster Termin, dem weitere folgen)
		                			// ( bereits erledigt s.o.: - kein Komma in Zeile (einziger Termin im Monat) )
		                			// ( bereits erledigt s.o.: - mit Komma davor (letzter Termin im Array): pos1 == -1 )
			                		//        				                				                			
			                		if ( zeile.lastIndexOf(',', pos1 ) != -1) { // wenn Termin davor vorhanden: 			                			
			                			// Neues Datum mit Komma davor:		
			        					neuesDatum = neuesDatum.append(",\""). // ,"
												append(tag).append("\",\""). // tag","
												append(text).append('\"'); // text"
										zeilenBuilder = ( new StringBuilder ( zeile.substring(0, zeile.lastIndexOf(',', pos1)) ) ).// Anfang bis vor/excl ,
												append(neuesDatum). // Komma, Datum und Text
												// ab incl. Komma vor pos1  bis Ende Zeile
												append(zeile.substring( zeile.lastIndexOf(',', pos1) , zeile.length() ) );
										//TestLog.o(DatenSetzen.class, "pos1: " + pos1 + "  lastIndexKomma: " + zeile.lastIndexOf(',', pos1 ));
										//TestLog.o(DatenSetzen.class, "1. Teil: " + zeile.substring(0, zeile.lastIndexOf(',', pos1)) );
										//TestLog.o(DatenSetzen.class, "2. Teil: " + neuesDatum);
										//TestLog.o(DatenSetzen.class, "3. Teil: " + zeile.substring(0, zeile.lastIndexOf(',', pos1)));
										break; // Terminschleife abbrechen
			                		} else { //pos1-Termin ist erster Termin im Monat 
			                			// neuer Termin wird erster Termin im Monat (dem weitere folgen)
			                			// neuer Termin mit FOLGENDEM Komma
			        					neuesDatum = neuesDatum.append('\"'). // "
												append(tag).append("\",\""). // tag","
												append(text).append("\","); // text",
										zeilenBuilder = ( new StringBuilder ( zeile.substring(0, zeile.indexOf('(') + 1) ) ).// Anfang bis incl (
												append(neuesDatum). // Datum, Text und Komma
												// ab incl. pos1  bis Ende Zeile
												append(zeile.substring( pos1 , zeile.length() ) );
					//TestLog.o(DatenSetzen.class, "zeile: " + zeile + "  zeilemBuilder: " + zeilenBuilder);
										break; // Terminschleife abbrechen
			                		}				                		
	            				} // Ende Position gefunden	
		                	}// Ende Termin-Schleife 
						} // Ende else es sind Termine enthalten
	                	zeile = zeilenBuilder.toString();             			                
					}	// else = richtige Zeile
					// Datums-Zeile in temp-Datei schreiben
	                buffWrite.append(zeile + lineSep) ;		
	 // TestLog.o(DatenSetzen.class, "zeile: " + zeile);
				} // Ende while Zeilen einlesen
								
			// Exception buffWrite
			} catch (IOException ioe) {
				JOptionPane.showMessageDialog(null, "Fehler bei Schreib-Zugriff auf die Datei "+ tempDatei);
				TestLog.o(DatenSetzen.class, ioe.getMessage());
				ioe.printStackTrace();
			} finally {
				if (buffWrite != null) {
					try {
						buffWrite.close();
					} catch (IOException ioe) {
						JOptionPane.showMessageDialog(null, "Fehler: Datei "+ tempDatei + " kann nicht geschlossen werden.");
						TestLog.o(DatenSetzen.class, ioe.getMessage());
					}
				}
			}		
		// Exceptin buffRead
		} catch (IOException ioe) {
			JOptionPane.showMessageDialog(null, "Fehler bei Lese-Zugriff auf die Datei "+ jsDatei);
			TestLog.o(DatenSetzen.class, ioe.getMessage());
			ioe.printStackTrace();
		} finally {
			if (buffRead != null) {
				try {
					buffRead.close();
				} catch (IOException ioe) {
					JOptionPane.showMessageDialog(null, "Fehler: Datei "+ jsDatei + " kann nicht geschlossen werden.");
					TestLog.o(DatenSetzen.class, ioe.getMessage());
				}
			}
		}
		
		// jsDatei in Datei mit Endung ".old" umbenennen
		// tempDatei als regulaere ".js"-Datei abspeichern 
		// -> Windows-Probleme bei renameTo: Bei Fehlschlag die alte Datei vorher loeschen
		try {
			if (jsDatei.renameTo(oldDatei) == false) {
				//JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ jsDatei.getPath() + " zu " + oldDatei.getPath() );
				if (oldDatei.exists() ) {
					if (oldDatei.delete() == false) {
						JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ jsDatei.getPath() + " zu " + oldDatei.getPath()  
								+ lineSep + oldDatei + " kann nicht geloescht werden");
					}
					else {
						if (jsDatei.renameTo(oldDatei) == false) {
							JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ jsDatei.getPath() + " zu " + oldDatei.getPath() );
						}
					}
				}
			}
			if (tempDatei.renameTo(jsDatei) == false) {
				//JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ tempDatei.getPath() + " zu " + jsDatei.getPath() );
				if (jsDatei.exists() ) {
					if (jsDatei.delete() == false) {
						JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ tempDatei.getPath() + " zu " + jsDatei.getPath()  
								+ lineSep + jsDatei + " kann nicht geloescht werden");
					}
					else {
						if (tempDatei.renameTo(jsDatei) == false) {
							JOptionPane.showMessageDialog(null, "Fehler bei Umbenennug von "+ tempDatei.getPath() + " zu " + jsDatei.getPath() );
						}
					}
				}
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Umbenennung fehlgeschlagen: " + oldDatei.getPath() + " und " + jsDatei.getPath());
			TestLog.o(DatenSetzen.class, e.getMessage());		
		}
		//
		// Pruefen, ob die geforderte Zeile enthalten war, sonst: neues Jahr eroeffnen
		if (zeileEnthalten == false) {
			//TestLog.o(DatenSetzen.class, "neues Jahr");
			boolean erfolg = false; 
			erfolg = neuesJahrEroeffnen(jahr);
			// nochmal versuchen:
			if (erfolg == true) { // sonst im Fehlerfal Endlosschleife
				terminSetzen(einmalig, jahr, monat, tag, text);
			}
		}
	}
	static void setJsFileName (String newFileName){
		jsDateiName= newFileName;
	}
	static void setMonthNames(String[] newNames) {
		monthNames = newNames;
	}
}
