package cologne.eck.note_pea;

/*
 * PeaFactory - Production of Password Encryption Archives
 * Copyright (C) 2015  Axel von dem Bruch
 * 
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, 
 * or (at your option) any later version.
 * This library is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * See:  http://www.gnu.org/licenses/gpl-2.0.html
 * You should have received a copy of the GNU General Public License 
 * along with this library.
 */

import java.awt.Component;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTextPane;

import cologne.eck.all_peas.data.PeaProperties;
import cologne.eck.tools.TestLog;



class CopyCutPastePopup extends JPopupMenu implements ActionListener {//, ClipboardOwner  {
	
	private static CopyCutPastePopup popup;
	
	private static final long serialVersionUID = 1L;
	private JMenuItem cut;
	private JMenuItem copy;
	private JMenuItem paste;
	//private JTextPane textComponent;
			
	// to register if a CopyCutPastePopup is displayed or not
	//private static boolean popupStarted = false;
	
	CopyCutPastePopup (Component invoker) {
		
		int fontSize = PeaProperties.getFontSize();//PswDialogView.getFontsize();	
		
//		textComponent = (JTextPane)invoker;
		cut = new JMenuItem(PeaProperties.getVmBridge().translate("cut"));
	    cut.addActionListener(this);
	    cut.setFont(new Font(Font.SANS_SERIF, Font.PLAIN, fontSize));
	    this.add(cut);
	    this.addSeparator();
	    copy = new JMenuItem(PeaProperties.getVmBridge().translate("copy"));
	    copy.addActionListener(this);
	    copy.setFont(new Font(Font.SANS_SERIF, Font.PLAIN, fontSize));
	    this.add(copy);
	    this.addSeparator();
	    paste = new JMenuItem(PeaProperties.getVmBridge().translate("paste"));
	    paste.addActionListener(this);
	    paste.setFont(new Font(Font.SANS_SERIF, Font.PLAIN, fontSize));
	    this.add(paste);		    
	    JPopupMenu.setDefaultLightWeightPopupEnabled(true);
	    this.setBorderPainted(true);		    
	    this.setInvoker(invoker);		    
	    this.pack();
	}


	@Override
	public void actionPerformed(ActionEvent ape) {
		
		if (ape.getSource() == cut) {
			JTextPane p = LockFrameEditor.getFocusedTextPane();
			if (p != null && p instanceof PeaTextPane) {
				//textComponent.copy();	
				p.cut();	
				popup.setVisible(false);

			} else {
				TestLog.ve(CopyCutPastePopup.class,"invalid JTextPane", 5);
			}
			/*textComponent.cut();
			popup.setVisible(false);
			if (textComponent.getContentType().equals("text/html") ){
				// register, that clipboard is set from PEA:
				NotebookSetting.setClipboardContentIsFromPEA(true);
			}*/
		}
		if (ape.getSource() == copy) {
			JTextPane p = LockFrameEditor.getFocusedTextPane();
			if (p != null && p instanceof PeaTextPane) {
				//textComponent.copy();	
				p.copy();	
				popup.setVisible(false);

			} else {
				TestLog.ve(CopyCutPastePopup.class,"invalid JTextPane", 5);
			}
		}
		if (ape.getSource() == paste) {
			JTextPane p = LockFrameEditor.getFocusedTextPane();
			if (p != null && p instanceof PeaTextPane) {
				p.paste(); 
				//	textComponent.paste(); 
				if (popup != null) {
					popup.setVisible(false);
				}
				return;
			} else {
				TestLog.ve(CopyCutPastePopup.class,"invalid JTextPane", 5);
			}
			
			// Content from clipboard from other applications
			// is mostly pasted not at all or falsely 
			// -> paste only content from this PEA and if HTML, otherwise insert plain text
			
/*			Clipboard clip = Toolkit.getDefaultToolkit().getSystemClipboard();
			if (clip.isDataFlavorAvailable(DataFlavor.stringFlavor) ){
				

				
				Transferable t = clip.getContents(this);
				DataFlavor[] flavors = t.getTransferDataFlavors();
				DataFlavor fl = DataFlavor.selectBestTextFlavor(flavors);
				
TestLog.v(CopyCutPastePopup.class, fl.getMimeType());

				// 1. Check appropriate mime type
				if (textComponent.getContentType().equals("text/html") ){
					if(  fl.getMimeType().equals("text/html; class=java.io.Reader")) {
						TestLog.v(CopyCutPastePopup.class, "Paste inside PEA");
						textComponent.paste(); 
						popup.setVisible(false);
						return;
					}
				} else if( textComponent.getContentType().equals("text/rtf")) {// fl.getMimeType().equals("application/x-java-serialized-object; class=java.lang.String")) {
TestLog.v(CopyCutPastePopup.class, "Paste RTF inside PEA");
						textComponent.paste(); 
						popup.setVisible(false);
						if (((LockFrameEditor)PeaControl.getDialog().getLockFrame()).isDocChangeUnsaved()) {
							return;			
						}
				}
				// 2. Fallback: Check if clipboard content was set from PEA
				// This does only work once
				if (NotebookSetting.isClipboardContentIsFromPEA() == true
					&&	textComponent.getContentType().equals("text/html")) {
					//for (DataFlavor f : flavors) {

					//	if (f.isMimeTypeEqual(textComponent.getContentType())) {
TestLog.v(CopyCutPastePopup.class, "Paste ONCE from PEA");
							// default paste
							textComponent.paste(); 
							NotebookSetting.setClipboardContentIsFromPEA(false);
							popup.setVisible(false);
							return;
					//	}
					//}
				}
				// 3.Fallback: From other applications: Insert plain text
				TestLog.ve(CopyCutPastePopup.class, "Insert plain text...");
				// try another way to insert					
				String data = "";
				try {
					// inserts plain text
					data = (String) clip.getData(DataFlavor.stringFlavor);
				} catch (HeadlessException e) {
					TestLog.ve(CopyCutPastePopup.class, e.getMessage() + " - " + e.toString(), 5);
				} catch (UnsupportedFlavorException e) {
					TestLog.ve(CopyCutPastePopup.class, e.getMessage() + " - " + e.toString(), 5);
				} catch (IOException e) {
					TestLog.ve(CopyCutPastePopup.class, e.getMessage() + " - " + e.toString(), 5);
				} 
				textComponent.replaceSelection(data);
			} // TODO images
			popup.setVisible(false);*/
		}		
	}
}
