package cologne.eck.peafactory.data;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Color;

import cologne.eck.tools.TestLog;


public class PeaFactoryProperties {
	
	/**
	 * background colors
	 */
	//private static Color peaColor = new Color(218, 242, 220);//Farbton 125,Saettigung 10, Wert 95
	private static Color peaColor = new Color(235, 255, 240); 
	
	/**
	 * size and location
	 */
	private static Dimension frameDim = new Dimension(550,450);
	private static Point frameLocation = new Point(100, 30);
	
	private static String lastLanguage = null;


	/**
	 * Set color of PeaFactory
	 * 
	 * @param last color of PeaFactory
	 */
	protected static void setPeaColor(Color newColor) {
		if (newColor != null) {
			PeaFactoryProperties.peaColor = newColor;
		} else {
			TestLog.ve(PeaFactoryProperties.class, "Missing Color to set", 5);
		}
	}
	/**
	 * Get last color of PeaFactory
	 * 
	 * @return	last color of PeaFactory
	 */
	protected static Color getPeaColor() {
		return peaColor;
	}
	/**
	 * Get the last frame dimension 
	 * 
	 * @return	last dimension
	 */
	protected static Dimension getFrameDim() {
		return frameDim;
	}
	
	/**
	 * Set the current frame dimension
	 * 
	 * @param the current dimension
	 */
	protected static void setFrameDim(Dimension newDim) {
		if (newDim != null) {
			PeaFactoryProperties.frameDim = newDim;
		} else {
			TestLog.ve(PeaFactoryProperties.class, "Missing Dimension to set", 5);
		}
	}
	
	/**
	 * Get last location of the frame
	 * 
	 * @return	last Point
	 */
	public static Point getFrameLocation() {
		return frameLocation;
	}
	
	/**
	 * Set current location as Point
	 * 
	 * @param current Point
	 */
	protected static void setFrameLocation(Point newPoint) {
		if (newPoint != null) {
			PeaFactoryProperties.frameLocation = newPoint;
		} else {
			TestLog.ve(PeaFactoryProperties.class, "Missing Point to set", 5);
		}
	}
	/**
	 * Get the last used language of the PeaFactory
	 * 
	 * @return the lastLanguage ("en" or "de")
	 */
	protected static String getLastLanguage() {
		return lastLanguage;
	}
	/**
	 * Set the current language of PeaFactory 
	 * 
	 * @param current language as String ("en" or "de")
	 */
	protected static void setLastLanguage(String lastLanguage) {
		PeaFactoryProperties.lastLanguage = lastLanguage;
	}
}
