package cologne.eck.tools;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.regex.Pattern;

public class LanguageHTMLHelper {

	
		/*
Create first_time_guide and cloud_guide:
1.	main: uncomment createKeys(), comment out others
	createKeys uncomment/comment out
	-> creates keys file: 
			cloud_guide.keys
			first_time_guide.keys
2.	Manually translate and create files with lang: cloud_guide.XX first_time_guide.XX
	Store in same folder as keys
3.	main: comment out createKeys, uncomment createTranslations()
	createTranslations(): uncomment infoFile part, add languages, comment out others
		 */
	
	/*
		1. set the html file to translate (simple-english and htmlFileName)
		2. create html-keys: createKeys()
		3. translate htmlKeys.txt manually from htmlKey.txt
		    create files in same folder as htmlKey.txt: html_es.txt, html_fr.txt ...
		4. create HTML files: createTraslations()
	*/
	

	/**
	 * Folder for info files in PEAs: first_time_guide and cloud_guide
	 */
	static String htmlInfoFolder = 	System.getProperty("user.dir") + File.separator 
			+ "all_peas" + File.separator + "info_files" + File.separator;


	//static String htmlFileName = "file_pea.html";
	//private static String simpleFilePEANameWithPath = "/media/ALL/prog/eck/peafactory/simple-english/html/file_pea_simple_en.html";
	//private static String htmlFileName = "calendar_pea.html";
	//private static String simpleFilePEANameWithPath = "/media/ALL/prog/eck/peafactory/simple-english/html/calendar_pea_simple_en.html";
	private static String htmlFileName = "notebook_pea.html";
	private static String simpleFilePEANameWithPath = "/media/ALL/prog/eck/peafactory/simple-english/html/notebook_pea_simple_en.html";


	
	//private static String folderName = System.getProperty("user.dir") + File.separator 
	//		+ "cal_pea_lang" + File.separator + "html" + File.separator;
	private static String folderName = System.getProperty("user.dir") + File.separator 
			+ "all_peas_lang" + File.separator + "html" + File.separator;
	// HTML tags
	static String metaDescriptionTag = "<meta name=\"description\" content=\"";
	static String metaKeyWordsTag = "<meta name=\"keywords\" content=\"";
	static String title = "<title>";//Protecting files with a password</title>";
	static String homeButton = "<a href=\"../../en/index.html\">";//Home</a>"; <a href="../../en/index.html">Home</a>
	static String downloadButton = "<button class=\"dropbtn\">";//Downloads</button>";
	static String infoButton = "<button class=\"dropbtn\">";//Information</button>";
	
	

	
	public static void main(String[] args) {
		
		//createKeys();
		
		// TODO translate manually.... 
		
		
		createTranslations();
	}
	
	private static void createKeys() {
				
		// create keys for HTML file for File Lock PEA
		
//		createSimpleEnglishKeyFile(simpleFilePEANameWithPath);
		
		// create keys for HTML file for Calendar Lock PEA
//		String simpleCalPEANameWithPath = "/media/ALL/prog/eck/peafactory/simple-english/html/calendar_pea_simple_en.html";
//		createSimpleEnglishKeyFile(simpleCalPEANameWithPath);
		
		
		// create keys for info texts: first_time_guide and cloud_guide
		String infoFile = System.getProperty("user.dir") + File.separator + "resources" + File.separator + "cloud_guide.html";
		createInfoTextKeyFile(infoFile);
		infoFile = System.getProperty("user.dir") + File.separator + "resources" + File.separator + "first_time_guide.html";
		createInfoTextKeyFile(infoFile);
		
	}
	
	private static void createTranslations() {		
		System.out.println("Translate HTML...");
		// translate HTML files for File Lock PEA
		//String simpleFilePEANameWithPath = "/media/ALL/prog/eck/peafactory/simple-english/html/file_pea_simple_en.html";
		//String htmlFileName = "file_pea.html";
		
/*		System.out.println("es");
		boolean esSuccess = createTranslatedHTML("es", simpleFilePEANameWithPath, htmlFileName);
		if (esSuccess == false) {
			System.err.println("Failed to create es");
		} else {
			System.out.println("Successfully created es");
		}
		
		System.out.println("ru");
		boolean ruSuccess = createTranslatedHTML("ru",  simpleFilePEANameWithPath, htmlFileName);
		if (ruSuccess == false) {
			System.err.println("Failed to create ru");
		} else {
			System.out.println("Successfully created ru");
		}
		
		System.out.println("fr");
		boolean frSuccess = createTranslatedHTML("fr", simpleFilePEANameWithPath, htmlFileName);
		if (frSuccess == false) {
			System.err.println("Failed to create fr");
		} else {
			System.out.println("Successfully created fr");
		}
		
		System.out.println("tr");
		boolean trSuccess = createTranslatedHTML("tr", simpleFilePEANameWithPath, htmlFileName);
		if (trSuccess == false) {
			System.err.println("Failed to create tr");
		} else {
			System.out.println("Successfully created tr");
		}
		
		
		
		
		
		// translate HTML files for Calendar Lock PEA
/*		String simpleCalPEANameWithPath = "/media/ALL/prog/eck/peafactory/simple-english/html/calendar_pea_simple_en.html";
		htmlFileName = "calendar_pea.html";
		createTranslatedHTML("ru",  simpleCalPEANameWithPath, htmlFileName);
		createTranslatedHTML("fr", simpleCalPEANameWithPath, htmlFileName);
		createTranslatedHTML("es", simpleCalPEANameWithPath, htmlFileName);
		
		*/
		
		// translate info files of PEAs: first_time_guide,cloud_guide
		String infoFile = System.getProperty("user.dir") + File.separator + "resources" + File.separator + "cloud_guide.html";
		try {
			createInfo("cn", infoFile);
			createInfo("cz", infoFile);
			createInfo("es", infoFile);			
			createInfo("fr", infoFile);
			createInfo("gr", infoFile);
			createInfo("it", infoFile);			
			createInfo("jp", infoFile);
			createInfo("lv", infoFile);
			createInfo("nl", infoFile);			
			createInfo("pt", infoFile);
			createInfo("ro", infoFile);
			createInfo("ru", infoFile);
			createInfo("tr", infoFile);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		
		// translate info files of PEAs: first_time_guide
		infoFile = System.getProperty("user.dir") + File.separator + "resources" + File.separator + "first_time_guide.html";
		try {
			createInfo("cn", infoFile);
			createInfo("cz", infoFile);
			createInfo("es", infoFile);			
			createInfo("fr", infoFile);
			createInfo("gr", infoFile);
			createInfo("it", infoFile);			
			createInfo("jp", infoFile);
			createInfo("lv", infoFile);
			createInfo("nl", infoFile);			
			createInfo("pt", infoFile);
			createInfo("ro", infoFile);
			createInfo("ru", infoFile);
			createInfo("tr", infoFile);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		
	}
	/**
	 * Create a file containing Strings (keys) to translate
	 * from a PEA info file (first_time_guide...):
	 * the file name with extension "keys"
	 */
	private static void createInfoTextKeyFile(String infoFile) {
		
		StringBuilder sb = new StringBuilder();
		
		
		String fileContent = new String(ReadResources.readExternFile(infoFile), StandardCharsets.UTF_8);
		String[] allLines = fileContent.split("\n");
		for (String line : allLines) {
			if (line.startsWith(" ") || line.startsWith("\t")) {
				
			} else {
				sb.append(line + "\n\n");
			}
		}
		
			
		// WRITE TO FILE:
		String htmlFileName = new File(infoFile).getName();
		String keyFileName = htmlFileName.substring(0, htmlFileName.lastIndexOf(".") + 1) + "keys";
		boolean writeSuccess = WriteResources.writeText(new String(sb), htmlInfoFolder + File.separator + keyFileName);
		if (writeSuccess != true) {
			System.err.println(WriteResources.getLastErrorMessage());
		}
		System.out.println("Info file created: " + htmlInfoFolder + File.separator + keyFileName);
	}
	
	/**
	 * Translate keys from info file and create a file
	 * in the target language
	 * 
	 * @param lang		the language to translate to
	 * @return			true for success, false otherwise
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	private static boolean createInfo(String lang, 
			String infoFile) throws FileNotFoundException, IOException {
		
		StringBuilder sb = new StringBuilder();
		
		String baseInfoFile = new File(infoFile).getName();
		String langFileName = baseInfoFile.substring(0, baseInfoFile.lastIndexOf(".") + 1) + lang;
		String langRead = htmlInfoFolder + File.separator + langFileName;
		
		BufferedReader brKey = new BufferedReader(new FileReader(infoFile));
		BufferedReader brLang = new BufferedReader(new FileReader(langRead));

		String keyLine;
		String langLine;
		while ((keyLine = brKey.readLine()) != null) {
			if (keyLine.startsWith(" ") || keyLine.startsWith("\t")) {
				sb.append(keyLine + "\n");
			} else {
				while ((langLine = brLang.readLine()) != null) {
					if (langLine.equals("")) {
					} else {
						sb.append(langLine + "\n");
						break;
					}
				}
			}
		}

		brKey.close();
		brLang.close();


		// WRITE TO FILE:
		String infoFileLang = baseInfoFile.substring(0, baseInfoFile.lastIndexOf(".") ) + "_" + lang + ".html";
		String newInfoFileName = htmlInfoFolder + infoFileLang;


		boolean writeSuccess = WriteResources.writeText(new String(sb), newInfoFileName);
		if (writeSuccess != true) {
			System.err.println(WriteResources.getLastErrorMessage());
		}
		System.out.println("Created: " + newInfoFileName);
		return writeSuccess;
	}
	
	/**
	 * Create the file "htmlKeys.txt"
	 * with keys for a PEA HTML file in simple English
	 * 
	 * @param simpleEnglishFileNameWithPath	 the file to translate
	 */
	private static void createSimpleEnglishKeyFile(String simpleEnglishFileNameWithPath) {
		
		StringBuilder sb = new StringBuilder();
		
		BufferedReader originReader = null;	
		try {
			originReader = new BufferedReader(new FileReader(new File(simpleEnglishFileNameWithPath)));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (originReader == null) {
			return;
		}
		
		try {
			String originLine = originReader.readLine();

			while (originLine != null) {

				if (originLine.startsWith(" ") || originLine.startsWith("\t")) {
					// HTML tags...
				} else {

					if ( ! originLine.trim().equals("en")) {
						// to translate
						sb.append(originLine);
						sb.append("\n\n");
					}
				}
				originLine = originReader.readLine();
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		
/*		String fileContent = new String(ReadResources.readExternFile(simpleEnglishFileNameWithPath), StandardCharsets.UTF_8);		
		int len = fileContent.split("</", -1).length;

		// HEAD 
		int metaDescriptionIndex = fileContent.indexOf(metaDescriptionTag);
		int metaDescriptionTagLen = metaDescriptionTag.length();
		String metaDescription = fileContent.substring(metaDescriptionIndex + metaDescriptionTagLen,// + "File Lock PEA: ".length(), 
				fileContent.indexOf("\">", metaDescriptionIndex));
		//System.out.println(metaDescription + "\n");
		sb.append(metaDescription + "\n\n");		
		
		int metaKeyWordsIndex = fileContent.indexOf(metaKeyWordsTag);
		int metaKeyWordsTagLen = metaKeyWordsTag.length();
		String metaKeyWords = fileContent.substring(metaKeyWordsIndex + metaKeyWordsTagLen , fileContent.indexOf("\">", metaKeyWordsIndex));
		//System.out.println(metaKeyWords + "\n");
		sb.append(metaKeyWords + "\n\n");
		
		int titleIndex = fileContent.indexOf(title);
		String titleContent = fileContent.substring(titleIndex + title.length(), 
				fileContent.indexOf("</title>"));
		//System.out.println(titleContent + "\n");
		sb.append(titleContent + "\n\n\n\n");
		
		
		
		// MENU
		int homeButtonIndex = fileContent.indexOf(homeButton);
		String homeButtonContent = fileContent.substring(homeButtonIndex + homeButton.length(), 
				fileContent.indexOf("</a>", homeButtonIndex));
		//System.out.println(homeButtonContent + "\n");
		sb.append(homeButtonContent + "\n\n");
		
		int downloadButtonIndex = fileContent.indexOf(downloadButton);
		String downloadButtonContent = fileContent.substring(downloadButtonIndex + downloadButton.length(), 
				fileContent.indexOf("</button>", downloadButtonIndex));
		//System.out.println(downloadButtonContent + "\n");
		sb.append(downloadButtonContent + "\n\n");
		
		int infoButtonIndex = fileContent.indexOf(infoButton, downloadButtonIndex +1);
		String infoButtonContent = fileContent.substring(infoButtonIndex + infoButton.length(), 
				fileContent.indexOf("</button>", infoButtonIndex));
		//System.out.println(infoButtonContent + "\n");
		sb.append(infoButtonContent + "\n\n\n\n");
		
		
		
		//  CONTENT HEADER
		for (int i = 0; i < len; i++) {
			int hIndex = fileContent.indexOf("id=\"#h2_" + i);
			if (hIndex != -1) {
				//System.out.println("hIndex: " + hIndex);
				String hContent = fileContent.substring(hIndex + ("id=\"#h2_" + i + "\">").length(), 
						fileContent.indexOf("</h2>", hIndex));
				//System.out.println(hContent.trim() + "\n");
				sb.append(hContent.trim() + "\n\n");
			} else {
				break;
			}
		}
		
		//  "#h2_5"
		for (int i = 0; i < len; i++) {
			int hIndex = fileContent.indexOf("id=\"#h3_" + i);
			if (hIndex != -1) {
				//System.out.println("hIndex: " + hIndex);
				String hContent = fileContent.substring(hIndex + ("id=\"#h3_" + i + "\">").length(), 
						fileContent.indexOf("</h3>", hIndex));
				//System.out.println(hContent.trim() + "\n");
				sb.append(hContent.trim() + "\n\n");
			} else {
				break;
			}
		}
		sb.append("\n\n");
		
		
		// CONTENT 
		for (int i = 1; i < len; i++) {
			int pIndex = fileContent.indexOf("id=\"#p_" + i + "\">");
			//System.out.println( "id=\"#p_" + i + "\">" + "  - index: " + pIndex);
			if (pIndex != -1) {
				//System.out.println("pIndex: " + pIndex);
				String pContent = fileContent.substring(pIndex + ("id=\"#p_" + i + "\">").length(), 
						fileContent.indexOf("</p>", pIndex));
				//System.out.println(pContent.trim() + "\n");
				sb.append(pContent.trim() + "\n\n");
			} else {
				break;
			}
		}		
		sb.append("\n\n");
		
		for (int i = 0; i < len; i++) {
			int pIndex = fileContent.indexOf("id=\"#li_" + i + "\">");
			//System.out.println( "id=\"#p_" + i + "\">" + "  - index: " + pIndex);
			if (pIndex != -1) {
				//System.out.println("pIndex: " + pIndex);	
				String liString = fileContent.substring(pIndex + ("id=\"#li_" + i + "\">").length(), fileContent.indexOf("</li>", pIndex));
				if (liString.contains("<em class")) {
					liString = liString.substring(liString.lastIndexOf("</em>") + 5, liString.length());
				}
				//System.out.println(liString.trim() + "\n");
				sb.append(liString.trim() + "\n\n");
			} else {
				break;
			}
		}	
		sb.append("\n\n");
		
		for (int i = 0; i < len; i++) {
			int pIndex = fileContent.indexOf("id=\"#span_" + i + "\">");
			//System.out.println( "id=\"#p_" + i + "\">" + "  - index: " + pIndex);
			if (pIndex != -1) {
				//System.out.println("pIndex: " + pIndex);				
				String spanContent = fileContent.substring(pIndex + ("id=\"#span_" + i + "\">").length(), 
						fileContent.indexOf("</span>", pIndex));
				//System.out.println(liContent.trim() + "\n");
				sb.append(spanContent.trim() + "\n\n");
			} else {
				break;
			}
		}	
		sb.append("\n\n");
		
		for (int i = 0; i < len; i++) {
			int pIndex = fileContent.indexOf("<input id=\"#input_" + i);
			if (pIndex != -1) {
				int valueIndex = fileContent.indexOf("value=\"", pIndex);
				if (valueIndex != -1) {
					int valueEndIndex = fileContent.indexOf("\"", valueIndex + 7);
					if (valueEndIndex != -1) {
						String inputValue = fileContent.substring(valueIndex + 7, valueEndIndex);
						if (inputValue != null && inputValue.trim().length() > 0) {
							//System.out.println(inputValue);
							sb.append(inputValue.trim() + "\n\n");
						}
					}
				}
				int inputRitleIndex = fileContent.indexOf("title=\"", pIndex);
				if (inputRitleIndex != -1) {
					int inputTitleEndIndex = fileContent.indexOf("\"", inputRitleIndex + 7);
					if (inputTitleEndIndex != -1) {
						String inputTitle = fileContent.substring(inputRitleIndex + 7, inputTitleEndIndex);
						if (inputTitle != null && inputTitle.trim().length() > 0) {
							//System.out.println(inputTitle);
							sb.append(inputTitle.trim() + "\n\n");
						}
					}
				}
			} else {
				break;
			}
		}	*/
		
		// WRITE TO FILE:
		boolean writeSuccess = WriteResources.writeText(new String(sb), folderName + "htmlKeys.txt");
		if (writeSuccess != true) {
			System.err.println(WriteResources.getLastErrorMessage());
		} else {
			System.out.println("Created " + folderName + "htmlKeys.txt");
		}
	}


	/**
	 * Create a translated HTML file for a PEA 
	 * from a HTML file in simple English
	 * 
	 * @param lang		language to translate to, e.g. "en","de","es"
	 * @param simpleEnglishFileNameWithPath	the file to translate
	 * @param fileNameToCreate	the translated PEA file name (in folder of language)
	 * 
	 * @return	true for success, false otherwise
	 */
	private static boolean createTranslatedHTML(String lang, 
			String simpleEnglishFileNameWithPath, 
			String fileNameToCreate) {


		//String values = new String(ReadResources.readExternFile(folderName + "html_" + lang + ".txt"), StandardCharsets.UTF_8).trim();

		// WRITE TO FILE:
		String newHTMLFileName = folderName + lang + File.separator + fileNameToCreate;
		System.out.println("Create file " + newHTMLFileName);

		BufferedReader originReader = null;	
		try {
			originReader = new BufferedReader(new FileReader(new File(simpleEnglishFileNameWithPath)));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (originReader == null) {
			return false;
		}

		BufferedReader valueReader = null;	
		try {
			valueReader = new BufferedReader(new FileReader(new File(folderName + "html_" + lang + ".txt")));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println("Read translations from " + folderName + "html_" + lang + ".txt");
		
		StringBuilder sb = new StringBuilder();
		//boolean nextOriginLineTrim = false;
		try {
			String originLine = originReader.readLine();

			while (originLine != null) {
			/*	if ( ! originLine.trim().startsWith("\"")) {
//					sb.append("\n");
				} else {
	//	System.out.println("originLine: " + originLine);
				}*/
				if (originLine.startsWith(" ") || originLine.startsWith("\t")) {
					

			/*		if ( originLine.trim().startsWith("\"")) {
						//sb = new StringBuilder( new String(sb).trim());
						System.out.println("   originLine: " + originLine);
						int lastIndex = 1;
						while ( Character.isWhitespace(sb.charAt(sb.length() - lastIndex))) {
							lastIndex++;
							System.out.println("DEL");
					       sb.deleteCharAt(sb.length() - lastIndex);
					    }				
					} */
					sb.append(originLine.trim());
					if ( ! originLine.trim().endsWith("\"")) {
						
						sb.append("\n");
					} else {
						// check if this is an end of a value:
						if (originLine.trim().indexOf("\"") < originLine.trim().length() -2) {
							sb.append(" ");
						}
					}
		

					//valueReader.readLine();
				} else if (originLine== null || originLine.trim().length() == 0) {
				} else if (originLine.trim().equals("en")) {
					sb.append(lang);
					//valueReader.readLine();
				} else if (originLine.equals("<!DOCTYPE html>")) {
					sb.delete(0, sb.length());// delete all characters before (TAB)
					sb.append(originLine.trim() + "\n");
				} else {  // 	
					// translate
		//			System.out.println("Translate: " + originLine);
					String valueLine = valueReader.readLine();
					if (valueLine != null) {
						while (valueLine.trim().length() == 0) {						
							valueLine = valueReader.readLine();
							if (valueLine == null) {
								break;
							}
						}
					}
		//			System.out.println(valueLine);
					if (valueLine != null) {
						sb.append(" " + valueLine.trim());
					}
				}
				originLine = originReader.readLine();
				if (originLine == null) {
					break;
				}
			}
		} catch (Exception e) {
			TestLog.e(LanguageHTMLHelper.class, e.getLocalizedMessage() + " - " + e.toString(), 5);
		}

			/*
		//String values = new String(ReadResources.readExternFile(folderName + "html_" + lang + ".txt"), StandardCharsets.UTF_8).trim();		
		String htmlContent = new String(ReadResources.readExternFile(simpleEnglishFileNameWithPath), StandardCharsets.UTF_8).trim();
		System.out.println("htmlContent length: " + htmlContent.length());
		int len = htmlContent.split("</", -1).length;
		BufferedReader valueReader = null;	
		try {
			valueReader = new BufferedReader(new FileReader(new File(folderName + "html_" + lang + ".txt")));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		//<html lang="en"> 
		//int metaLan = htmlContent.indexOf("<html lang=");
		String langTag = htmlContent.substring(htmlContent.indexOf("<html lang="), htmlContent.indexOf("<html lang=") + 16);
		htmlContent = htmlContent.replaceFirst(langTag, "<html lang=\"" + lang + "\">" );
		//System.out.println(htmlContent);

		try {
			// HEAD 
			int metaDescriptionIndex = htmlContent.indexOf(metaDescriptionTag);
			int metaDescriptionTagLen = metaDescriptionTag.length();
			String metaDescription = htmlContent.substring(metaDescriptionIndex + metaDescriptionTagLen,
					htmlContent.indexOf("\">", metaDescriptionIndex));

			htmlContent = replace(valueReader, htmlContent, metaDescription);
			System.out.println("htmlContent length: " + htmlContent.length());
			//System.out.println(htmlContent);


			int metaKeyWordsIndex = htmlContent.indexOf(metaKeyWordsTag);
			int metaKeyWordsTagLen = metaKeyWordsTag.length();
			String metaKeyWords = htmlContent.substring(metaKeyWordsIndex + metaKeyWordsTagLen , htmlContent.indexOf("\">", metaKeyWordsIndex));
			System.out.println("metagKeyWords: " + metaKeyWords);
			htmlContent = replace(valueReader, htmlContent, metaKeyWords);

			int titleIndex = htmlContent.indexOf(title);
			String titleContent = htmlContent.substring(titleIndex + title.length(), 
					htmlContent.indexOf("</title>"));

			htmlContent = replace(valueReader, htmlContent, titleContent);




			// MENU
			int homeButtonIndex = htmlContent.indexOf(homeButton);
			String homeButtonContent = htmlContent.substring(homeButtonIndex + homeButton.length(), 
					htmlContent.indexOf("</a>", homeButtonIndex));

			htmlContent = replace(valueReader, htmlContent, homeButtonContent);

			int downloadButtonIndex = htmlContent.indexOf(downloadButton);
			String downloadButtonContent = htmlContent.substring(downloadButtonIndex + downloadButton.length(), 
					htmlContent.indexOf("</button>", downloadButtonIndex));

			htmlContent = replace(valueReader, htmlContent, downloadButtonContent);

			int infoButtonIndex = htmlContent.indexOf(infoButton, downloadButtonIndex +1);
			String infoButtonContent = htmlContent.substring(infoButtonIndex + infoButton.length(), 
					htmlContent.indexOf("</button>", infoButtonIndex));

			htmlContent = replace(valueReader, htmlContent, infoButtonContent);



			//  CONTENT HEADER
			for (int i = 0; i < len; i++) {
				int hIndex = htmlContent.indexOf("id=\"#h2_" + i);
				if (hIndex != -1) {
					//System.out.println("hIndex: " + hIndex);
					String hContent = htmlContent.substring(hIndex + ("id=\"#h2_" + i + "\">").length(), 
							htmlContent.indexOf("</h2>", hIndex));

					htmlContent = replace(valueReader, htmlContent, hContent);
				} else {
					break;
				}
			}

			//  "#h2_5"
			for (int i = 0; i < len; i++) {
				int hIndex = htmlContent.indexOf("id=\"#h3_" + i);
				if (hIndex != -1) {
					//System.out.println("hIndex: " + hIndex);
					String hContent = htmlContent.substring(hIndex + ("id=\"#h3_" + i + "\">").length(), 
							htmlContent.indexOf("</h3>", hIndex));

					htmlContent = replace(valueReader, htmlContent, hContent);
				} else {
					break;
				}
			}
			//sb.append("\n\n");


			// CONTENT 
			for (int i = 0; i < len; i++) {
				int pIndex = htmlContent.indexOf("id=\"#p_" + i + "\">");
				if (pIndex != -1) {
					//System.out.println("pIndex: " + pIndex);
					String pContent = htmlContent.substring(pIndex + ("id=\"#p_" + i + "\">").length(), 
							htmlContent.indexOf("</p>", pIndex));
					htmlContent = replace(valueReader, htmlContent, pContent);
				} else {
					break;
				}
			}		


			for (int i = 0; i < len; i++) {
				int pIndex = htmlContent.indexOf("id=\"#li_" + i + "\">");
				//System.out.println( "id=\"#p_" + i + "\">" + "  - index: " + pIndex);
				if (pIndex != -1) {
					//System.out.println("pIndex: " + pIndex);				
					String liContent = htmlContent.substring(pIndex + ("id=\"#li_" + i + "\">").length(), 
							htmlContent.indexOf("</li>", pIndex));
					if (liContent.contains("<em class")) {
						liContent = liContent.substring(liContent.lastIndexOf("</em>") + 5, liContent.length());
					}
					htmlContent = replace(valueReader, htmlContent, liContent);
					//System.out.println(liContent);
				} else {
					break;
				}
			}	

			for (int i = 0; i < len; i++) {
				int pIndex = htmlContent.indexOf("id=\"#span_" + i + "\">");
				//System.out.println( "id=\"#p_" + i + "\">" + "  - index: " + pIndex);
				if (pIndex != -1) {
					//System.out.println("pIndex: " + pIndex);				
					String spanContent = htmlContent.substring(pIndex + ("id=\"#span_" + i + "\">").length(), 
							htmlContent.indexOf("</span>", pIndex));
					htmlContent = replace(valueReader, htmlContent, spanContent);
				} else {
					break;
				}
			}

			for (int i = 0; i < len; i++) {
				int pIndex = htmlContent.indexOf("<input id=\"#input_" + i);
				if (pIndex != -1) {
					int valueIndex = htmlContent.indexOf("value=\"", pIndex);
					if (valueIndex != -1) {
						int valueEndIndex = htmlContent.indexOf("\"", valueIndex + 7);
						if (valueEndIndex != -1) {
							String inputValue = htmlContent.substring(valueIndex + 7, valueEndIndex);
							if (inputValue != null && inputValue.trim().length() > 0) {
								//System.out.println(inputValue);
								htmlContent = replace(valueReader, htmlContent, inputValue);
							}
						}
					}
					int inputRitleIndex = htmlContent.indexOf("title=\"", pIndex);
					if (inputRitleIndex != -1) {
						int inputTitleEndIndex = htmlContent.indexOf("\"", inputRitleIndex + 7);
						if (inputTitleEndIndex != -1) {
							String inputTitle = htmlContent.substring(inputRitleIndex + 7, inputTitleEndIndex);
							if (inputTitle != null && inputTitle.trim().length() > 0) {
								//System.out.println(inputTitle);
								htmlContent = replace(valueReader, htmlContent, inputTitle);
							}
						}
					}
				} else {
					break;
				}
			}

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/



			//System.out.println( newHTMLFileName);
			//  		htmlFileName.substring(0, htmlFileName.indexOf("."))
			//  + "_" + lang + ".html";
			boolean writeSuccess = WriteResources.writeText(new String(sb), newHTMLFileName);
			if (writeSuccess != true) {
				System.err.println(WriteResources.getLastErrorMessage());
			} else {
				System.out.println("Created " + lang + " - " + newHTMLFileName);
				return true;
			}

		System.out.println("Created: " + newHTMLFileName);
		return false;
	}
	/**
	 * Replace the origin String by a translated String 
	 * 
	 * @param valueReader	the Reader, reading the original String
	 * @param content	the whole content, which is to be replaced step by step
	 * @param origin	the origin String to be replaced
	 * 
	 * @return	the resulting content, where the origin waas replaced
	 */
	private static String replace(BufferedReader valueReader, String content, String origin) {
		String replacement;
		try {
			replacement = valueReader.readLine();
			while (replacement == null) {
				replacement = valueReader.readLine();
			}
			// ignore empty lines
			while (replacement.trim().length() == 0) {
				replacement = valueReader.readLine();
			}		
System.out.println("replacement: " + replacement);
			// append all not empty lines
			String nextLine = valueReader.readLine();
			while( nextLine  != null) {
				nextLine = nextLine.trim();
				replacement += " " + nextLine;
				nextLine = valueReader.readLine();
			}		
	System.out.println(origin);
	System.out.println(replacement+"\n");
			content =   content.replaceFirst(Pattern.quote(origin), replacement);
			return content;
			//System.out.println(content);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.err.println("Origin: " + origin);
			e.printStackTrace();
			return null;
		}  catch (Exception e) {
			// TODO Auto-generated catch block
			System.err.println("Origin: " + origin);
			e.printStackTrace();
			return null;
		}
		
	}
}
